The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Echo Class Reference

STK echo effect class. More...

`#include <Echo.h>`

Inheritance diagram for stk::Echo:

## Public Member Functions
| Echo (unsigned long maximumDelay=(unsigned long) Stk::sampleRate())
| Class constructor, taking the longest desired delay length (one second default value).
void | clear ()
| Reset and clear all internal state.
void | setMaximumDelay (unsigned long delay)
| Set the maximum delay line length in samples.
void | setDelay (unsigned long delay)
| Set the delay line length in samples.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the effect and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the effect and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the effect and write outputs to the `oFrames` object.
Public Member Functions inherited from stk::Effect
| Effect (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual void | clear ()=0
| Reset and clear all internal state.
virtual void | setEffectMix (StkFloat mix)
| Set the mixture of input and "effected" levels in the output (0.0 = input only, 1.0 = effect only).
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK echo effect class.

This class implements an echo effect.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ Echo()

stk::Echo::Echo | ( | unsigned long | maximumDelay = `(unsigned long) Stk::sampleRate()` | ) |

Class constructor, taking the longest desired delay length (one second default value).

The default delay value is set to 1/2 the maximum delay length.

## Member Function Documentation

## ◆ tick() [1/2]

StkFrames & stk::Echo::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inline

Take a channel of the StkFrames object as inputs to the effect and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

79{
80#if defined(_STK_DEBUG_)
81 if ( channel >= frames.channels() ) {
82 oStream_ << "Echo::tick(): channel and StkFrames arguments are incompatible!";
83 handleError( StkError::FUNCTION_ARGUMENT );
84 }
85#endif
86
87 StkFloat *samples = &frames[channel];
88 unsigned int hop = frames.channels();
89 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
90 *samples = effectMix_ * ( delayLine_.tick( *samples ) - *samples ) + *samples;
91 }
92
93 lastFrame_[0] = *(samples-hop);
94 return frames;
95}
stk::Delay::tick
StkFloat tick(StkFloat input)
Input one sample to the filter and return one output.
Definition Delay.h:124
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [2/2]

StkFrames & stk::Echo::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the effect and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

98{
99#if defined(_STK_DEBUG_)
100 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
101 oStream_ << "Echo::tick(): channel and StkFrames arguments are incompatible!";
102 handleError( StkError::FUNCTION_ARGUMENT );
103 }
104#endif
105
106 StkFloat *iSamples = &iFrames[iChannel];
107 StkFloat *oSamples = &oFrames[oChannel];
108 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
109 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
110 *oSamples = effectMix_ * ( delayLine_.tick( *iSamples ) - *iSamples ) + *iSamples;
111 }
112
113 lastFrame_[0] = *(oSamples-oHop);
114 return iFrames;
115}

The documentation for this class was generated from the following file:

- Echo.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.